﻿using UnityEditor;
using UnityEngine;

[CustomEditor(typeof (Triangle))]
public class TriangleInspector : Editor
{
    private static GUIContent pointContent = GUIContent.none;
    //private static GUILayoutOption colorWidth = GUILayout.MaxWidth(50f);

    private SerializedObject triangle;

    private SerializedProperty normal;
    private SerializedProperty points;

    private void OnEnable()
    {
        triangle = new SerializedObject(target);
        normal = triangle.FindProperty("normal");
        points = triangle.FindProperty("points");
    }

    public override void OnInspectorGUI()
    {
        triangle.Update();

        EditorGUILayout.PropertyField(normal);

        GUILayout.Label("Points");
        for (int i = 0; i < points.arraySize; i++)
        {
            EditorGUILayout.BeginHorizontal();
            SerializedProperty point = points.GetArrayElementAtIndex(i);
            EditorGUILayout.PropertyField(point, pointContent);
            EditorGUILayout.EndHorizontal();
        }

        if (triangle.ApplyModifiedProperties())
        {
            ((Triangle) target).UpdateMesh();
        }
    }
}