﻿using UnityEngine;

public abstract class GamepadInput : MonoBehaviour
{
    public enum Button
    {
        A,
        B,
        X,
        Y,
        Start,
        Back,
        LeftBack,
        RightBack
    }

    public enum Axis
    {
        PrimaryX,
        PrimaryY,
        SecondaryX,
        SecondaryY,
        Trigger
    }

    public abstract bool GetButton(int gamepadIndex, Button button);
    public abstract bool GetButtonDown(int gamepadIndex, Button button);
    public abstract bool GetButtonUp(int gamepadIndex, Button button);

    public abstract bool GetButton(Button button);
    public abstract bool GetButtonDown(Button button);
    public abstract bool GetButtonUp(Button button);

    public abstract float GetAxis(int gamepadIndex, Axis axis);

    public abstract void SetLowestVibrationThisFrame(int gamepadIndex, float left, float right);
}
