﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using UnityEngine;

public class VisualSettingsBase<T> : SingletonMonoBehaviour<T> where T : VisualSettingsBase<T>
{
    [SerializeField] private Font fontTitle;
    [SerializeField] private Font fontDefault;
    [SerializeField] private bool fontTitleAllUpperCase = false;

    [SerializeField] private Color buttonColorNormal = Color.white;
    [SerializeField] private Color buttonColorHovered = new Color(0.2f, 0.2f, 1f);
    [SerializeField] private Color buttonColorDeactivated = new Color(0.4f, 0.4f, 0.4f);
    [SerializeField] private Color buttonColorMarked = Color.yellow;

    public Font FontTitle { get { return fontTitle; } }
    public Font FontDefault { get { return fontDefault; } }

    public bool FontTitleAllUpperCase { get { return fontTitleAllUpperCase; } }

    public Color ButtonColorNormal { get { return buttonColorNormal; } }
    public Color ButtonColorHovered { get { return buttonColorHovered; } }
    public Color ButtonColorDeactivated { get { return buttonColorDeactivated; } }
    public Color ButtonColorMarked { get { return buttonColorMarked; } }
}
