using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using UnityEngine;

public class SfxManager : SfxManagerBase<SfxManager>
{
    [SerializeField] private AudioClipWithVolume buttonHovered;
    [SerializeField] private AudioClipWithVolume buttonClicked;
    [SerializeField] private AudioClipWithVolume[] soundEffectGroupExample;
    [SerializeField] private AudioClipWithVolume loopedSoundExample;
    
    private AudioSource loopedSoundExampleAudioSource;

    public bool PlayLoopedSoundExample
    {
        get { return IsAudioSourcePlaying(loopedSoundExampleAudioSource); }
        set { SetAudioSourcePlaying(loopedSoundExampleAudioSource, value); }
    }

    protected override void Awake()
    {
        base.Awake();

        loopedSoundExampleAudioSource = CreateAudioSource(loopedSoundExample);
    }

    public void PlayButtonClicked()
    {
        PlaySound(buttonClicked);
    }

    public void PlayButtonHovered()
    {
        PlaySound(buttonHovered);
    }

    public void PlaySoundEffectGroupExample()
    {
        PlaySound(soundEffectGroupExample);
    }
}
