﻿using UnityEngine;

[ExecuteInEditMode]
public class RageGlowSimple : MonoBehaviour
{
    private RageSpline rageSpline;
    private AbstractRageShape myAbstractShape;
    protected AbstractRageShape parentShape;

    protected void Awake()
    {
        transform.localPosition = new Vector3(transform.localPosition.x, transform.localPosition.y, 1);
    }

    protected void OnEnable()
    {
        myAbstractShape = GetComponent<AbstractRageShape>();
        rageSpline = GetComponent<RageSpline>();
        parentShape = transform.parent.GetComponent<AbstractRageShape>();

        parentShape.EventRefreshedColor += OnParentShapeRefreshedColor;
        parentShape.EventRefreshedColorAlpha += OnParentShapeRefreshedColorAlpha;
    }

    protected void OnDisable()
    {
        parentShape = transform.parent.GetComponent<AbstractRageShape>();

        parentShape.EventRefreshedColor -= OnParentShapeRefreshedColor;
        parentShape.EventRefreshedColorAlpha -= OnParentShapeRefreshedColorAlpha;
    }

    private void OnParentShapeRefreshedColor(Color? outlineColor, Color? fillColor, Color? outlineColorGlow)
    {
        Color? fillColorGlow = (rageSpline.GetFill() != RageSpline.Fill.None) ? outlineColorGlow : null;
        myAbstractShape.RefreshColors(outlineColorGlow, fillColorGlow, null);
    }

    private void OnParentShapeRefreshedColorAlpha(float percent)
    {
        myAbstractShape.RefreshColors(percent);
    }
}
